using Bp.Sync.BackEnd.Infrastructure.Repositories.FcBusinesses;
using Bp.Sync.Dto.Results;
using CommonLibrary;
using Dapper;
using EasyNetQ;
using Microsoft.Extensions.Configuration;
using System;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Threading;
using System.Threading.Tasks;
using Vina.Search.Infrastructure.Mappings;

namespace Bp.Sync.BackEnd.Application.Commands.FcBusinesses.Bills
{
    public class SyncFcReceiptBillHandler : MediatR.IRequestHandler<SyncFcReceiptBillCommand, BaseResult>
    {
        private readonly IDbConnection _dbConnection;
        private readonly IFcReceiptBillRepository _FcReceiptBillRepository;
        private readonly IBus _bus;

        public SyncFcReceiptBillHandler(IConfiguration configuration, IFcReceiptBillRepository FcReceiptBillRepository, IBus bus)
        {
            var connectionString = configuration.GetConnectionString("FcBusinessConnection");
            _dbConnection = new SqlConnection(connectionString);
            _FcReceiptBillRepository = FcReceiptBillRepository;
            _bus = bus;
        }

        public async Task<BaseResult> Handle(SyncFcReceiptBillCommand request, CancellationToken cancellationToken)
        {
            var rs = new BaseResult();

            if (request.Ids.Count() > 1000)
            {
                var length = request.Ids.Count();
                if (length > 0)
                {
                    for (int i = 0; i <= length / 1000; i++)
                    {
                        if (length > i * 1000)
                        {
                            var ids = request.Ids.Skip(i * 1000).Take(1000).ToList();
                            if (ids.Count() > 0)
                            {
                                await _bus.SendAsync($"SyncToElasticFcReceiptBill", ids.ConvertListLongToString());
                            }
                        }
                    }
                }
                return new BaseResult { Result = Result.Success, Message = $"sent {length} FcReceiptBills" };
            }

            if (!request.Ids.Any())
            {
                rs.Message = $"no data to update";
                rs.Result = Dto.Results.Result.Success;
                return rs;
            }
            try
            {
                var p = new Dto.DapperTypes.IdsParam(request.Ids);
                var FcReceiptBills = await _dbConnection.QueryAsync<Domain.Entities.FcBusinesses.Bills.ReceiptBill>("Sync_ReceiptBill_Get_By_List_Id", p, commandType: CommandType.StoredProcedure);
                if (FcReceiptBills.Any())
                {
                    var FcReceiptBillRs = FcReceiptBills.ToFcReceiptBills();
                    var rs2 = await _FcReceiptBillRepository.AddManyAsync(FcReceiptBillRs);
                    if (rs2.Result == Result.Success)
                    {
                        await _dbConnection.ExecuteAsync("Synced_ReceiptBill_By_List_Id", p, commandType: CommandType.StoredProcedure);
                        rs.Message = $"{FcReceiptBillRs.Count()} synced";
                        rs.Result = Result.Success;
                    }
                    else
                    {
                        rs.Message = $"can not insert db";
                        rs.Result = Result.Success;
                    }
                }
                else
                {
                    rs.Message = $"no data to update";
                    rs.Result = Result.Success;
                }
            }
            catch (Exception ex)
            {
                rs.Message = ex.Message.ToString();
                rs.Result = Result.SystemError;
            }
            return rs;
        }
    }
}